unit untOperater;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, fphttpclient, lockbox;

// code
function _serverCompileRun(ATmpPath: string; AEmail: string; AProjName: string; AMainFile: string; ACodeType: Integer): string;

// user
function _userRegister(AAccount: string; APassword: string; AEmail: string; ANickname: string): string;
function _userLogin(AAccount: string; APassword: string): string;
function _userInfo(AGuid: string): string;
function _userPerm(AGuid: string): string;
function _userChangePassword(AGuid: string; AOldPass: string; ANewPass: string): string;
function _userChangeNickname(AGuid: string; ANickname: string): string;
function _userChangeEmail(AGuid: string; AEmail: string): string;

// sync
function _syncList(AGuid: string): string;
function _syncDownload(AGuid: string; AProjName: string): string;
function _syncUpload(AProjPath: string; ATmpPath: string; AGuid: string; AProjName: string): string;
function _syncDelete(AGuid: string; AProjName: string): string;

var
  URL_CODER: string = 'http://120.27.9.223/coding';
  URL_ACCOUNT: string = 'http://120.27.9.223/account';
  URL_SYNC: string = 'http://120.27.9.223/sync';

implementation

function md5EncryptString(str: string): string;
var
  d: TMD5Digest;
  ret: string = '';
begin
  try
    StringHashMD5(d, str);
    ret := BufferToHex(d, SizeOf(d));
  except
  end;
  Exit(ret);
end;

function _serverCompileRun(ATmpPath: string; AEmail: string; AProjName: string;
  AMainFile: string; ACodeType: Integer): string;
var
  AZip: string;
  jstr: string = '';
  param: TStringList;
  ss: TStringStream;
begin
  // request server
  if (not ATmpPath.EndsWith('/')) then ATmpPath += '/';
  AZip:= ATmpPath + 'a.zip';
  if (FileExists(AZip)) then begin
    with TFPHTTPClient.Create(nil) do begin
      param := TStringList.Create;
      param.Add(Format('email=%s', [AEmail]));
      param.Add(Format('projName=%s', [AProjName]));
      param.Add(Format('mainFile=%s', [AMainFile]));
      param.Add(Format('codeType=%d', [ACodeType]));
      ss := TStringStream.Create('');
      try
        FileFormPost(URL_CODER, param, 'archive', AZip, ss);
        jstr := ss.DataString;
      except
      end;
      ss.Free;
      param.Free;
      Free;
    end;
  end;
  Exit(jstr);
end;

function _userRegister(AAccount: string; APassword: string; AEmail: string;
  ANickname: string): string;
var
  jstr: string = '';
  param: TStringList;
begin
  APassword:= md5EncryptString(APassword);
  with TFPHTTPClient.Create(nil) do begin
    param := TStringList.Create;
    param.Add('action=reg');
    param.Add(Format('account=%s', [AAccount]));
    param.Add(Format('password=%s', [APassword]));
    param.Add(Format('email=%s', [AEmail]));
    param.Add(Format('nickname=%s', [ANickname]));
    try
      jstr := FormPost(URL_ACCOUNT, param);
    except
    end;
    param.Free;
    Free;
  end;
  Exit(jstr);
end;

function _userLogin(AAccount: string; APassword: string): string;
var
  jstr: string = '';
  param: TStringList;
begin
  APassword:= md5EncryptString(APassword);
  with TFPHTTPClient.Create(nil) do begin
    param := TStringList.Create;
    param.Add('action=login');
    param.Add(Format('account=%s', [AAccount]));
    param.Add(Format('password=%s', [APassword]));
    try
      jstr := FormPost(URL_ACCOUNT, param);
    except
    end;
    param.Free;
    Free;
  end;
  Exit(jstr);
end;

function _userInfo(AGuid: string): string;
var
  jstr: string = '';
  param: TStringList;
begin
  with TFPHTTPClient.Create(nil) do begin
    param := TStringList.Create;
    param.Add('action=info');
    param.Add(Format('guid=%s', [AGuid]));
    try
      jstr := FormPost(URL_ACCOUNT, param);
    except
    end;
    param.Free;
    Free;
  end;
  Exit(jstr);
end;

function _userPerm(AGuid: string): string;
var
  jstr: string = '';
  param: TStringList;
begin
  with TFPHTTPClient.Create(nil) do begin
    param := TStringList.Create;
    param.Add('action=perm');
    param.Add(Format('guid=%s', [AGuid]));
    try
      jstr := FormPost(URL_ACCOUNT, param);
    except
    end;
    param.Free;
    Free;
  end;
  Exit(jstr);
end;

function _userChangePassword(AGuid: string; AOldPass: string; ANewPass: string
  ): string;
var
  jstr: string = '';
  param: TStringList;
begin
  AOldPass:= md5EncryptString(AOldPass);
  ANewPass:= md5EncryptString(ANewPass);
  with TFPHTTPClient.Create(nil) do begin
    param := TStringList.Create;
    param.Add('action=pwd');
    param.Add(Format('guid=%s', [AGuid]));
    param.Add(Format('oldpass=%s', [AOldPass]));
    param.Add(Format('newpass=%s', [ANewPass]));
    try
      jstr := FormPost(URL_ACCOUNT, param);
    except
    end;
    param.Free;
    Free;
  end;
  Exit(jstr);
end;

function _userChangeNickname(AGuid: string; ANickname: string): string;
var
  jstr: string = '';
  param: TStringList;
begin
  with TFPHTTPClient.Create(nil) do begin
    param := TStringList.Create;
    param.Add('action=nick');
    param.Add(Format('guid=%s', [AGuid]));
    param.Add(Format('nickname=%s', [ANickname]));
    try
      jstr := FormPost(URL_ACCOUNT, param);
    except
    end;
    param.Free;
    Free;
  end;
  Exit(jstr);
end;

function _userChangeEmail(AGuid: string; AEmail: string): string;
var
  jstr: string = '';
  param: TStringList;
begin
  with TFPHTTPClient.Create(nil) do begin
    param := TStringList.Create;
    param.Add('action=email');
    param.Add(Format('guid=%s', [AGuid]));
    param.Add(Format('email=%s', [AEmail]));
    try
      jstr := FormPost(URL_ACCOUNT, param);
    except
    end;
    param.Free;
    Free;
  end;
  Exit(jstr);
end;

function _syncList(AGuid: string): string;
var
  jstr: string = '';
  param: TStringList;
begin
  with TFPHTTPClient.Create(nil) do begin
    param := TStringList.Create;
    param.Add('action=list');
    param.Add(Format('guid=%s', [AGuid]));
    try
      jstr := FormPost(URL_SYNC, param);
    except
    end;
    param.Free;
    Free;
  end;
  Exit(jstr);
end;

function _syncDownload(AGuid: string; AProjName: string): string;
var
  jstr: string = '';
  param: TStringList;
begin
  with TFPHTTPClient.Create(nil) do begin
    param := TStringList.Create;
    param.Add('action=download');
    param.Add(Format('guid=%s', [AGuid]));
    param.Add(Format('projName=%s', [AProjName]));
    try
      jstr := FormPost(URL_SYNC, param);
    except
    end;
    param.Free;
    Free;
  end;
  Exit(jstr);
end;

function _syncUpload(AProjPath: string; ATmpPath: string; AGuid: string;
  AProjName: string): string;
var
  AZip: string;
  param: TStringList;
  ss: TStringStream;
  jstr: string;
begin
  if (not ATmpPath.EndsWith('/')) then ATmpPath += '/';
  AZip:= ATmpPath + 'a.zip';
  if (FileExists(AZip)) then begin
    with TFPHTTPClient.Create(nil) do begin
      param := TStringList.Create;
      param.Add('action=upload');
      param.Add(Format('guid=%s', [AGuid]));
      param.Add(Format('projName=%s', [AProjName]));
      ss := TStringStream.Create('');
      try
        FileFormPost(URL_SYNC, param, 'file', AZip, ss);
        jstr := ss.DataString;
      except
      end;
      ss.Free;
      param.Free;
      Free;
    end;
  end;
  Exit(jstr);
end;

function _syncDelete(AGuid: string; AProjName: string): string;
var
  param: TStringList;
  jstr: string = '';
begin
  with TFPHTTPClient.Create(nil) do begin
    param := TStringList.Create;
    param.Add('action=delete');
    param.Add(Format('guid=%s', [AGuid]));
    param.Add(Format('projName=%s', [AProjName]));
    try
      jstr := FormPost(URL_SYNC, param);
    except
    end;
    param.Free;
    Free;
  end;
  Exit(jstr);
end;

end.

